## rmilter 1.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 SET(RMILTER_VERSION_MAJOR 1)
 SET(RMILTER_VERSION_MINOR 6)
-SET(RMILTER_VERSION_PATCH 0)
+SET(RMILTER_VERSION_PATCH 1)
 
 SET(RMILTER_VERSION         "${RMILTER_VERSION_MAJOR}.${RMILTER_VERSION_MINOR}.${RMILTER_VERSION_PATCH}")
 SET(RMILTER_MASTER_SITE_URL "https://rspamd.com")
