=== debian/changelog ===
rmilter (1.6.1) unstable; urgency=medium

  * Initial upload (Closes: #741161)

 -- Mikhail Gusarov <dottedmag@debian.org>  Mon, 10 Mar 2014 00:55:10 +0100
