=== debian/control ===
Source: rmilter
Section: mail
Priority: extra
Maintainer: Mikhail Gusarov <dottedmag@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), cmake, libpcre3-dev, libssl-dev (>= 1.0), libopendkim-dev, libmilter-dev, libspf2-dev, bison, flex
Standards-Version: 3.9.5
Homepage: https://github.com/vstakhov/rmilter
Vcs-Git: git://github.com/vstakhov/rmilter.git
Vcs-Browser: https://github.com/vstakhov/rmilter

Package: rmilter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Recommends: sendmail | postfix
Description: Another sendmail milter for different mail checks
 rmilter is a standalone application that provides the following features:
  SPF checks;
  greylisting using memcached storage;
  ratelimits using memcached storage;
  checking mail via rspamd/spamassassin;
  checking mail via clamav antivirus;
  regexp filters;
  DKIM signing;
  beanstalk operations for specific messages.
 .
 Rmilter uses sendmail milter interface and is compatible with Sendmail 
 and Postfix MTA  as well as with other MTA that supports milter interface.
