=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_SPF=ON \
		-DENABLE_DKIM=ON \
		-DMANDIR=/usr/share/man
