=== debian/changelog ===
rmilter (1.6.3) unstable; urgency=low

  * New release.

 -- Mikhail Gusarov <dottedmag@debian.org>  Sat, 18 Jul 2015 22:11:32 +0200

rmilter (1.6.2) unstable; urgency=low

  * Use systemd socket activation.
  * Bump Standards-Version to 3.9.6, no changes required

 -- Mikhail Gusarov <dottedmag@debian.org>  Sat, 21 Feb 2015 18:40:13 +0100
