=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with systemd

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_SPF=ON \
		-DENABLE_DKIM=ON \
		-DMANDIR=/usr/share/man

override_dh_systemd_enable:
	dh_systemd_enable rmilter.socket

override_dh_systemd_start:
	dh_systemd_start --restart-after-upgrade --no-start

override_dh_installinit:
	dh_installinit -n
